
-- CVS Header
-- $Author: test4j $
-- $Date: 2008/04/23 14:54:10 $
-- $Revision: 1.19 $
-- $Source: /usr/home/test4j/cvs/all/utils/mkper/mkper.4gl,v $
-- $Log: mkper.4gl,v $
-- Revision 1.19  2008/04/23 14:54:10  test4j
--
-- Handle VERIFY attribute
--
-- Revision 1.18  2008/04/23 14:46:58  test4j
--
-- Handle TYPE override.
--
-- Revision 1.17  2008/04/23 14:24:11  test4j
--
-- handle PICTURE attribute
--
-- Revision 1.16  2008/04/23 14:05:52  test4j
--
-- handle matrix better
--
-- Revision 1.15  2008/04/23 13:25:29  test4j
--
-- fixed handling of forms already done
--
-- Revision 1.14  2008/03/14 11:16:35  test4j
-- More fixes
--
-- Revision 1.13  2007/10/03 08:22:04  test4j
-- changes from copenhagen
--
-- Revision 1.8  2005/05/10 14:58:49  test4j
-- CVS Heading Added.
--

-- Program to produce Genero .per files from bdl forms compiled with Genero.
-- 									By Neil J Martin ( neilm@4js.com )
-- Example:
-- 	cust.per < bdl form file
-- 	fglform cust.per	< compile with genero form compiler.
--	fglrun mkper cust.42f
--			This will back up original cust.per to cust.per.njm
--			Reads the cust.42f
--			Create a new Genero cust.per and then compile it.
--			If the BDL form had a keys section then a keys.xml file is also made.
--			The keys.xml can be used as a .4ad file.
--	
-- Usage:
-- fglrun mkper objformname -- Change a specific form (inc .42f ).
-- or
-- fglrun mkper ALL	-- Reads ALL .42f from current directory.
--
-- The program converts the RIP widgets to be Genero widgtes.
-- Example:
--	f003 = FORMONLY.comb, WIDGET="COMBO", CONFIG="lines=6",
--												OPTIONS="-nolist",
--								INCLUDE=("", "ITEM 1","ITEM 2","ITEM 3","ITEM 4","ITEM 5");
-- Becomes:
-- 	COMBOBOX f003 = FORMONLY.comb, 
--				ITEMS=("", "ITEM 1","ITEM 2","ITEM 3","ITEM 4","ITEM 5");
--
-- 0.4 : Customer specific stuff added
-- 0.5 : Now handles, COLOR=, COMMENT= and COMINO style comments at top of form.
--
-- Known Limits:
--	Genero fglform doesn't handle BDL style Foldertabs
--	mkper won't turn array lists into TABLEs
--
-- Customer Specific Mods:	New environment variable MKPER_CUST ( upshifted )
--

&include "mkper.inc"

	DEFINE g_titl STRING
	DEFINE scr DYNAMIC ARRAY OF CHAR(200)
	DEFINE field DYNAMIC ARRAY OF RECORD
			id CHAR(5),
			ty CHAR(20),
			tb CHAR(18),
			nm CHAR(18),
			ar CHAR(350)
		END RECORD
	DEFINE fields SMALLINT
	DEFINE max_scr SMALLINT
	DEFINE l,scr_x,scr_y SMALLINT
	DEFINE single,double1, double2 SMALLINT
	DEFINE dbname STRING

	DEFINE tabs DYNAMIC ARRAY OF CHAR(28)
	DEFINE no_of_tabs SMALLINT

	DEFINE key DYNAMIC ARRAY OF CHAR(20)
	DEFINE key_name DYNAMIC ARRAY OF CHAR(50)
	DEFINE no_of_keys SMALLINT

	DEFINE chan base.Channel
	DEFINE per base.Channel
	DEFINE cust CHAR(10)

	DEFINE act_doc om.DomDocument
	DEFINE actions om.DomNode

	DEFINE chase_ky SMALLINT
	DEFINE ver STRING

	DEFINE conv_labs, ignore_genero_forms SMALLINT
	DEFINE labno SMALLINT
	DEFINE labtxt DYNAMIC ARRAY OF STRING
MAIN
	DEFINE fname STRING
	DEFINE x SMALLINT
	DEFINE k_doc om.DomDocument
	DEFINE k_node om.DomNode
	DEFINE key_node om.DomNode

	LET no_of_keys = 1

	LET conv_labs = FALSE
	LET ignore_genero_forms = TRUE
	LET ver = "$Id$" -- If NULL then TIMESTAMP is used.

	DISPLAY copyright," ",version

	LET cust = UPSHIFT(fgl_getenv("MKPER_CUST"))
	IF cust IS NULL THEN LET cust = " " END IF
	DISPLAY "Customer Specific code:",cust

	LET fname = ARG_VAL(1)
	LET dbname = ARG_VAL(2)
	IF ARG_VAL(3) = "Y" THEN
		LET conv_labs = TRUE
	END IF 

	IF dbname IS NULL OR dbname = " " THEN
		IF cust = "X1" THEN LET dbname = "db1" END IF
		IF cust = "X2" THEN LET dbname = "db2" END IF
		IF cust = "X3" THEN LET dbname = "db3" END IF
		IF cust = "X4" THEN LET dbname = "db4" END IF
	END IF
	DISPLAY "Database:",dbname	

	IF cust = "CHASEIT" OR cust = "COMINO" THEN
		LET act_doc = om.DomDocument.createFromXMLFile("rules.xml")
		IF act_doc IS NULL THEN
			DISPLAY "Failed to read rules.xml file!"
			EXIT PROGRAM
		END IF
		LET actions = act_doc.getDocumentElement()
	END IF

	IF fname = "ALL" THEN
		CALL prog_all()
	ELSE
		CALL prog_form( fname )
	END IF
	
	IF cust != "CHASEIT" AND cust != "COMINO"  THEN
		LET k_doc = om.DomDocument.create("DefaultActions")
		LET k_node  = k_doc.getDocumentElement()
--		DISPLAY "Keys:"
		FOR x = 1 TO no_of_keys
			IF key[x] IS NOT NULL AND key[x] != " " THEN
				LET key_node = k_node.createChild("Action")
				CALL key_node.setAttribute("acceleratorName",key[x] CLIPPED)
				CALL key_node.setAttribute("name",key[x] CLIPPED)
				CALL key_node.setAttribute("text",key_name[x] CLIPPED)
	--			DISPLAY key[x]," ",key_name[x]
			END IF
		END FOR
		CALL k_node.writeXML("keys.xml")
	END IF

	DISPLAY "Finished."

END MAIN
--------------------------------------------------------------------------------
FUNCTION prog_all() 
	DEFINE buffer CHAR(100)
	DEFINE ch base.Channel

	DISPLAY "Opening Pipe..."
	LET ch=base.Channel.create()

	CALL ch.openPipe("ls -1 *.42f","r")
	IF STATUS != 0 THEN
		DISPLAY "Error with open pipe:",STATUS
		EXIT PROGRAM
	END IF
	DISPLAY "Reading from pipe..."
	WHILE ch.read(buffer)
		DISPLAY buffer CLIPPED
		CALL prog_form( buffer CLIPPED )
	END WHILE
	CALL ch.close()

END FUNCTION
--------------------------------------------------------------------------------
FUNCTION prog_form( fname ) 
	DEFINE f_doc om.DomDocument
	DEFINE f_node om.DomNode
	DEFINE fname STRING
	DEFINE outname STRING
	DEFINE bakname STRING
	DEFINE nl om.nodeList
	DEFINE x SMALLINT
	DEFINE cmd CHAR(80)

	LET fields = 0
	LET single = 0
	LET double1 = 0
	LET double2 = 1
	LET no_of_tabs = 0
	LET max_scr = 0
	LET chase_ky = 0

	LET chan=base.Channel.create()
	FOR x = 1 TO 500
		INITIALIZE scr[x] TO NULL
		INITIALIZE field[x].* TO NULL
	END FOR
	FOR x = 1 TO 50
		INITIALIZE tabs[x] TO NULL
	END FOR

	LET f_doc = om.DomDocument.create("Form")
	LET f_node  = f_doc.getDocumentElement()
	DISPLAY "Reading ",fname.trim()," ..."
	LET f_node = f_node.loadXml( fname )
	IF f_node IS NULL THEN
		DISPLAY "Failed to read:",fname
		EXIT PROGRAM
	END IF
	
	LET nl = f_node.selectByPath("//Screen")
	IF nl.getLength() = 0 AND ignore_genero_forms THEN
		DISPLAY "Genero Form already:",fname.trim()," ignoring it."
		RETURN
	END IF
	
	LET x = fname.getindexof(".",1)
	IF x = 0 THEN
		LET outname = "t.per"
	ELSE
		LET outname = fname.substring(1,x)
		LET bakname = outname.append("per.njm")
		LET outname = outname.append("per")
		LET cmd = "mv ",outname.trim()," ",bakname.trim()
		RUN cmd
		LET cmd = "chmod 400 ",bakname.trim()
		RUN cmd
	END IF

	DISPLAY "Opening ",outname.trim()," for writing ,,."
	CALL chan.openFile(outname,"w")
	IF STATUS != 0 THEN
		DISPLAY "Error:",STATUS
		EXIT PROGRAM
	END IF
	CALL chan.setDelimiter("")

	IF cust = "COMINO" THEN
		CALL find_top_comments( bakname )
	END IF

	CALL do_it( f_node, fname.subString(1,x-1) )
	
	DISPLAY "Closing ",outname.trim()
	CALL chan.close()

	DISPLAY "Compiling ",outname.trim()," ..."
	LET cmd = "fglform ",outname.trim()
	RUN cmd

END FUNCTION
--------------------------------------------------------------------------------
FUNCTION do_it( st_node, fname )
	DEFINE st_node om.DomNode
	DEFINE fname STRING
	DEFINE x SMALLINT

	IF dbname IS NOT NULL AND dbname != " " THEN
		CALL out( "SCHEMA " || dbname )
	END IF
	CALL out( "" )

	IF cust = "CHASEIT" THEN -- set ver from f60 for SCCS details
		CALL mkper_keys( st_node )	
	END IF

	LET labno = 0
	CALL labtxt.clear()
	LET g_titl = ""
	CALL mkper_layout( st_node, FALSE)	
	IF ver IS NOT NULL THEN
		CALL out( "LAYOUT (TEXT=%\"\", STYLE=\"maint\", VERSION=\""||ver||"\")" )
	ELSE
		IF g_titl IS NULL THEN LET g_titl = fname END IF
		CALL out( "LAYOUT (TEXT=%\""||g_titl||"\", STYLE=\"maint\", VERSION=TIMESTAMP )" )
	END IF
	CALL out( "GRID" )
	CALL out( "{" )
	CALL mkper_layout( st_node, TRUE )	
	CALL out( "}" )
	CALL out( "END -- GRID" )

	IF dbname IS NOT NULL AND dbname != " " THEN
		CALL mkper_tabs( st_node )	
		IF no_of_tabs > 0 THEN
			CALL out( "TABLES" )
			FOR x = 1 TO no_of_tabs
				CALL out( tabs[x] )
			END FOR
		END IF
	END IF
	CALL out( "" )
	CALL out( "ATTRIBUTES" )
	IF conv_labs THEN
		FOR x = 1 TO labtxt.getLength()
			CALL out("LABEL l"||(x USING "<<<")||" : lab"||(x USING "<<<")||",TEXT=%\""||labtxt[x]||"\",STYLE=\"lab\";")
		END FOR
		CALL out( "" )
	END IF
	CALL mkper_attr( st_node )	
	CALL out( "END" )
		CALL out( "" )
	CALL out( "INSTRUCTIONS" )
	CALL mkper_recs( st_node )	
	CALL out( "END" )

	IF cust = "CHASEIT" THEN -- chase only haev f60 for SCCS
		CALL mkper_keys( st_node )	
	END IF
END FUNCTION
--------------------------------------------------------------------------------
FUNCTION find_top_comments(source)
	DEFINE source,line, tmp STRING
	DEFINE ret SMALLINT

	LET per=base.Channel.create()
	DISPLAY "Opening ",source.trim()," for reading,,."
	CALL per.openFile(source,"r")
	IF STATUS != 0 THEN
		DISPLAY "Error:",STATUS
		EXIT PROGRAM
	END IF
	CALL per.setDelimiter("")

	LET ret = 1
	WHILE ret > 0
		LET ret = per.Read( line )	
		IF ret = 1 THEN
			LET tmp = UPSHIFT( line.trim() )
			IF tmp.subString(1,8) = "DATABASE" 
			OR tmp.subString(1,6) = "SCREEN" THEN EXIT WHILE END IF
			CALL out( line )
		END IF
	END WHILE
	
	DISPLAY "Closing ",source.trim()
	CALL per.close()

END FUNCTION
--------------------------------------------------------------------------------
FUNCTION mkper_layout( st_node, proc )
	DEFINE st_node om.DomNode
	DEFINE proc SMALLINT
	DEFINE n om.DomNode
	DEFINE nl om.NodeList
	DEFINE x SMALLINT
	
	LET nl = st_node.selectByPath("//Screen")
	IF nl.getLength() != 1 THEN
--		DISPLAY "Error ",nl.getLength()," Nodes found for //Screen."
--		LET nl = st_node.selectByPath("//Grid")
--		IF nl.getLength() = 0 THEN LET nl = st_node.selectByPath("//ScrollGrid") END IF
--		IF nl.getLength() = 0 THEN LET nl = st_node.selectByPath("//Table") END IF
		LET n = st_node
	ELSE
--		DISPLAY "Converting SCREEN to LAYOUT"
		LET n = nl.item(1)
	END IF
	LET n = n.getFirstChild()

	WHILE  n IS NOT NULL
--		DISPLAY n.getTagname()
		IF n.getTagname() = "Label" THEN
			IF n.getAttribute("posY") = 0 THEN	
				LET g_titl = n.getAttribute("text")
				IF NOT proc THEN RETURN	END IF
			ELSE
				IF proc THEN CALL mkper_lab( n ) END IF
			END IF
		END IF
		IF proc THEN
			IF n.getTagname() = "FormField" THEN
				IF mkper_ff( n ) THEN
					LET n = n.getNext()
					CONTINUE WHILE
				END IF
			END IF
			IF n.getTagname() = "Matrix" THEN
				IF mkper_ff( n ) THEN
				END IF
			END IF
			IF n.getTagname() = "HLine" THEN
				CALL mkper_lab( n )
			END IF
			IF n.getTagname() = "RipGraphic" THEN
				CALL mkper_lab( n )
			END IF
		END IF
		LET n = n.getNext()
	END WHILE
	IF NOT proc THEN RETURN	END IF
	FOR x = 1 TO max_scr
		CALL out(scr[x] CLIPPED )
	END FOR

END FUNCTION
--------------------------------------------------------------------------------
FUNCTION mkper_lab( n )
	DEFINE n om.DomNode
	DEFINE txt STRING
	DEFINE l2, maxlen SMALLINT
	
	LET scr_x = n.getAttribute("posX") + 1
	LET scr_y = n.getAttribute("posY") + 1
	LET txt = n.getAttribute("text")

	IF n.getTagName() = "RipGraphic" THEN
		LET scr[scr_y][scr_x,scr_x] = "-"
		RETURN
	END IF
	IF n.getTagName() = "HLine" THEN
		LET scr[scr_y][scr_x,scr_x+n.getAttribute("gridWidth")] = 
"--------------------------------------------------------------------------------"
		RETURN
	END IF

	IF n.getTagName() = "Label" THEN
		LET l = txt.getLength()
		IF cust = "CHASEIT" THEN
--			DISPLAY "chase_ky:",chase_ky," scr_y:",scr_y," txt:",txt
			IF txt = "Home" THEN 
				LET chase_ky = scr_y
				RETURN 
			END IF
			IF txt = "f1" AND scr_y = chase_ky THEN RETURN END IF
			IF txt = "f2" AND scr_y = chase_ky THEN RETURN END IF
			IF txt = "f3" AND scr_y = chase_ky THEN RETURN END IF
			IF txt = "f4" AND scr_y = chase_ky THEN RETURN END IF
			IF txt = "f5" AND scr_y = chase_ky THEN RETURN END IF
			IF txt = "f6" AND scr_y = chase_ky THEN RETURN END IF
			IF txt = "f7" AND scr_y = chase_ky THEN RETURN END IF
			IF txt = "f8" AND scr_y = chase_ky THEN RETURN END IF
			IF txt = "f9" AND scr_y = chase_ky THEN RETURN END IF
			IF txt = "f10" AND scr_y = chase_ky THEN RETURN END IF
			IF txt = "f11" AND scr_y = chase_ky THEN RETURN END IF
			IF txt = "f12" AND scr_y = chase_ky THEN RETURN END IF
			IF txt = "f13" AND scr_y = chase_ky THEN RETURN END IF
			IF txt = "f14" AND scr_y = chase_ky THEN RETURN END IF
			IF txt = "f15" AND scr_y = chase_ky THEN RETURN END IF
			IF txt = "End" AND scr_y = chase_ky THEN RETURN END IF
		END IF
	END IF
	IF conv_labs AND l > 0 THEN
		LET maxlen = 5
		IF labno < 9 THEN LET maxlen = 4 END IF
		IF l > (maxlen - 1) THEN
			LET l2 = l - (maxlen - 1)
			LET labno = labtxt.getLength() + 1
			LET labtxt[labno] = txt
			LET txt = "[l"||(labno USING "<<<")
			LET l2 = l - txt.getLength()
			LET txt = txt||(l2 SPACES)||"]"
		ELSE
			DISPLAY "Label not converted:",txt
		END IF
	END IF

	LET scr[scr_y][scr_x,scr_x+l] = txt

	IF scr_y > max_scr THEN LET max_scr = scr_y END IF

END FUNCTION
--------------------------------------------------------------------------------
FUNCTION mkper_ff( ff )
	DEFINE ff,ty om.DomNode
	DEFINE f,a_h, a_s, y,x,t SMALLINT
	DEFINE config CHAR(200)
	DEFINE myTok base.StringTokenizer
	DEFINE myStr STRING
	
	LET ty = ff.getFirstChild()

	LET f = ff.getAttribute("fieldId")
	LET scr_x = ty.getAttribute("posX")
	LET scr_y = ty.getAttribute("posY") + 1

	LET fields = fields + 1
	LET a_h = 0
	LET a_s = 1

	LET field[fields].tb = ff.getAttribute("sqlTabName")
	LET field[fields].nm = ff.getAttribute("colName")

	IF cust = "SSP" THEN
		IF field[fields].tb = "formonly" AND field[fields].nm = "junk" THEN
			LET field[fields].ty = "RIP"
			RETURN FALSE
		END IF
	END IF

	LET field[fields].ty = UPSHIFT(ty.getTagName())

	IF ty.getTagName() = "RipLABEL" THEN
		LET field[fields].ty = "LABEL"
	END IF

	LET myStr = ff.getAttribute("sqlType")
	IF ff.getAttribute("sqlTabName") = "formonly" AND myStr.getLength() > 0 THEN
		IF myStr.subString(1,4) != "CHAR" THEN
			LET field[fields].ar = field[fields].ar CLIPPED, " TYPE "||myStr
		END IF
	END IF

	IF ty.getTagName() = "RipCOMBO" THEN
		LET field[fields].ty = "COMBOBOX"
		LET myStr = ff.getAttribute("include")
		LET myTok = base.StringTokenizer.create(myStr,"|")
		LET config = "'"
		LET config = config CLIPPED, myTok.nextToken()
		WHILE myTok.hasMoreTokens()
			LET config = config CLIPPED, "','"
			LET config = config CLIPPED, myTok.nextToken()
		END WHILE
		LET field[fields].ar = ", ITEMS=(",config CLIPPED,"')"
	END IF

	IF ty.getTagName() = "RipRADIO" THEN
		LET field[fields].ty = "RADIOGROUP"
		LET config = ty.getAttribute("config")
		LET field[fields].ar = ", ITEMS=(('"
		LET x = LENGTH(field[fields].ar) + 1
		FOR y = 1 TO LENGTH( config )
				CASE config[y]
					WHEN " " 
					WHEN "{" 
						LET field[fields].ar[x] = "'"
						LET x = x + 1
						LET field[fields].ar[x] = ","
						LET x = x + 1
						LET field[fields].ar[x] = "'"
						LET x = x + 1
					WHEN "}"
						LET field[fields].ar[x] = "'"
						LET x = x + 1
						LET field[fields].ar[x] = "),"
						LET x = x + 1
						LET field[fields].ar[x] = ","
						LET x = x + 1
						LET field[fields].ar[x] = "("
						LET x = x + 1
						LET field[fields].ar[x] = "'"
						LET x = x + 1
					OTHERWISE
						LET field[fields].ar[x] = config[y]
						LET x = x + 1
				END CASE
		END FOR
		LET field[fields].ar[x-3,x] = ")    "
	END IF

	IF ty.getTagName() = "RipBUTTON" THEN
		LET config = ff.getAttribute("colName")
		IF cust = "CHASEIT" THEN
			IF config = "ok_button" THEN RETURN FALSE END IF
			IF config = "help_button" THEN RETURN FALSE END IF
			IF config = "more_button" THEN RETURN FALSE END IF
			IF config = "edit_button" THEN RETURN FALSE END IF
			IF config = "print_button" THEN RETURN FALSE END IF
			IF config = "cancel_button" THEN RETURN FALSE END IF
		END IF
		LET field[fields].ty = "BUTTON"
		LET field[fields].tb = NULL
		LET field[fields].nm = ty.getAttribute("config")
		IF field[fields].nm IS NULL OR field[fields].nm = " " THEN
			LET field[fields].nm = "fld",ff.getAttribute("fieldId")
		END IF
		IF cust != "SSP" THEN
			LET field[fields].ar = ", TEXT='",DOWNSHIFT(config) CLIPPED,"'"
		END IF
	END IF

	IF ty.getTagName() = "RipCHECK" THEN
		LET field[fields].ty = "CHECKBOX"
		LET config = ty.getAttribute("config")
		LET field[fields].ar = ", VALUECHECKED='",config[1],"'"
		LET field[fields].ar = field[fields].ar CLIPPED,
										", VALUEUNCHECKED='",config[3],"'"
		LET l = LENGTH(config)
		IF l > 6 THEN
			LET config = config[6,l-1]
			LET field[fields].ar = field[fields].ar CLIPPED,
										", TEXT='",config CLIPPED,"'"
		END IF
	END IF

	IF ty.getTagName() = "RipFIELD_BMP" THEN
		LET field[fields].ty = "BUTTONEDIT"
		LET config = ty.getAttribute("config")
		FOR y = 1 TO LENGTH( config )
			IF config[y] = "." THEN
				IF cust != "CHASEIT" THEN
					LET field[fields].ar = ", IMAGE='",config[1,y-1],"'"
				END IF
					LET field[fields].ar = field[fields].ar CLIPPED," ,SCROLL"
			END IF
			IF config[y] = " " THEN
				LET config = config[y+1,100]
				EXIT FOR
			END IF
		END FOR
		IF cust = "CHASEIT" OR cust = "COMINO" THEN
			LET field[fields].ar = field[fields].ar CLIPPED,
										", ACTION=",keyact(config) CLIPPED
		ELSE
			LET field[fields].ar = field[fields].ar CLIPPED,
										", ACTION=",DOWNSHIFT(config) CLIPPED
		END IF
	END IF

	IF ty.getTagName() = "RipBMP" THEN
		LET field[fields].ty = "BUTTON"
		LET field[fields].tb = NULL
		LET config = ty.getAttribute("config")
		FOR y = 1 TO LENGTH( config )
			IF config[y] = "." THEN
				LET field[fields].ar = ", IMAGE='",config[1,y-1],"'"
			END IF
			IF config[y] = " " THEN
				LET config = config[y+1,100]
				EXIT FOR
			END IF
		END FOR
		LET field[fields].nm = config
	END IF

	IF ty.getTagName() = "TextEdit" THEN
		LET a_h = ty.getAttribute("height") - 1
	END IF

	IF ty.getTagName() = "Canvas" THEN
		LET a_h = ty.getAttribute("height") - 1
	END IF

	IF ff.getAttribute("noEntry") = "1" THEN
		IF field[fields].ty != "BUTTON" AND field[fields].ty != "LABEL" THEN
			LET field[fields].ar = field[fields].ar CLIPPED, ", NOENTRY"
		END IF
	END IF

	IF ff.getAttribute("required") = "1" THEN
		LET field[fields].ar = field[fields].ar CLIPPED, ", REQUIRED"
	END IF

	IF ff.getAttribute("notNull") = "1" THEN
		LET field[fields].ar = field[fields].ar CLIPPED, ", NOT NULL"
	END IF

	IF ty.getAttribute("comment") THEN
		LET field[fields].ar = field[fields].ar CLIPPED, ", COMMENT=%\"",ty.getAttribute("comment") CLIPPED,"\""
	END IF

	IF ty.getAttribute("defaultValue") THEN
		LET field[fields].ar = field[fields].ar CLIPPED,
									", DEFAULT=\"",ty.getAttribute("defaultValue") CLIPPED,"\""
	END IF

	IF ty.getAttribute("autoNext") = "1"  THEN
		LET field[fields].ar = field[fields].ar CLIPPED, ", AUTONEXT"
	END IF

	IF field[fields].ty != "BUTTON" AND field[fields].ty != "LABEL" THEN
		IF ty.getAttribute("shift") = "up"  THEN
			LET field[fields].ar = field[fields].ar CLIPPED, ", UPSHIFT"
		END IF
		IF ty.getAttribute("shift") = "down"  THEN
			LET field[fields].ar = field[fields].ar CLIPPED, ", DOWNSHIFT"
		END IF
	END IF

	LET myStr = ff.getAttribute("defaultValue")
	IF myStr.getLength() > 0 THEN
		LET field[fields].ar = field[fields].ar CLIPPED, ", DEFAULT=\""||myStr||"\""
	END IF

	LET myStr = ty.getAttribute("picture")
	IF myStr.getLength() > 0 THEN
		LET field[fields].ar = field[fields].ar CLIPPED, ", PICTURE=\"",myStr,"\""
	END IF

	LET myStr = ty.getAttribute("verify")
	IF myStr.getLength() > 0 THEN
		LET field[fields].ar = field[fields].ar CLIPPED, ", VERIFY"
	END IF

	LET myStr = ff.getAttribute("include")
	IF myStr.getLength() > 0 THEN
		LET t = myStr.getIndexOf(":",1)
		IF t > 0 THEN
			LET config = myStr.subString(1,t-1)||" TO "||myStr.subString(t+1, myStr.getLength() )
		ELSE
			LET myTok = base.StringTokenizer.createExt(myStr,"|","\\",TRUE)
			LET config = "'"
			LET config = config CLIPPED, myTok.nextToken()
			WHILE myTok.hasMoreTokens()
				LET config = config CLIPPED, "','"
				LET config = config CLIPPED, myTok.nextToken()
			END WHILE
			LET config = config CLIPPED||"'"
		END IF
		LET field[fields].ar = field[fields].ar CLIPPED, ", INCLUDE=("||config CLIPPED||")"
		DISPLAY "Include:",myStr,":",config
	END IF

	IF ty.getAttribute("color") THEN
		LET field[fields].ar = field[fields].ar CLIPPED,
									", STYLE='",ty.getAttribute("color") CLIPPED,"'"
	END IF

	IF ff.getTagName() = "Matrix" THEN
		LET a_h = ff.getAttribute("pageSize") - 1
		LET a_s = ff.getAttribute("stepY")
		IF a_s IS NULL THEN LET a_s = 1 END IF
		--DISPLAY "h:", ff.getAttribute("pageSize")," colname:",ff.getAttribute("colName")
	END IF

	LET l = ty.getAttribute("width")
	LET field[fields].id = "f",f USING "<<<&"
	IF l = 1 THEN 
		LET single = single + 1
		LET field[fields].id = ASCII(96)+single 
	END IF
	IF l = 2 THEN 
		LET double1 = double1 + 1
		IF double1 > 26 THEN
			LET double1 = 1
			LET double2 = double2 + 1
		END IF
		LET field[fields].id = NULL
		LET field[fields].id[1] = ASCII(96)+double2
		LET field[fields].id[2] = ASCII(96)+double1
	END IF
	LET config = field[fields].id
	FOR y = scr_y TO scr_y + (a_h*a_s) STEP a_s
--		DISPLAY "Loop:",y," a_h:",a_h," a_s:",a_s," config:",config CLIPPED
		IF scr[y][scr_x] = "]" THEN
			LET scr[y][scr_x,scr_x+l] = "|", config CLIPPED
		ELSE
			LET scr[y][scr_x,scr_x+l] = "[", config CLIPPED
		END IF
		LET scr[y][scr_x+l+1] = "]"
		IF ty.getTagName() = "TextEdit" THEN
			LET config = " "
		END IF
	END FOR
	IF y > max_scr THEN LET max_scr = y END IF

	RETURN TRUE

END FUNCTION
--------------------------------------------------------------------------------
FUNCTION mkper_keys( st_node )
	DEFINE st_node om.DomNode
	DEFINE n om.DomNode
	DEFINE nl om.NodeList
	DEFINE x,x1 SMALLINT
	DEFINE accName STRING
	DEFINE accText STRING
	DEFINE tex CHAR(50)

	LET nl = st_node.selectByPath("//Action")
	FOR x = 1 TO nl.getLength()
		LET n = nl.item(x)
		LET accName = DOWNSHIFT(n.getAttribute("acceleratorName"))
		LET accText = n.getAttribute("text")
		CASE accName
			WHEN "esc" LET accName = "escape"
			WHEN "cr" LET accName = "return"
			WHEN "enter" LET accName = "return"
		END CASE
		IF accText IS NULL OR accText = " " THEN
			CONTINUE FOR
		END IF
		IF cust = "CHASEIT" AND accName = "f60" THEN
-- Add keys section for F60 SCCS Key entry.
--			DISPLAY "accText:",accText
--			CALL out( "KEYS" )
--			CALL out( "	\"f60\"   = \""||accText CLIPPED||"\"" )
--			CALL out( "END" )
			LET ver = accText -- used in VERSION in LAYOUT 
		END IF
		LET x1 = accText.getindexof("-",1)
		IF x1 > 0 THEN
			LET tex = accText.trim()
			LET l = accText.getLength()
			IF tex[x1+1] = " " THEN 
				LET tex = tex[1,x1-1], tex[x1+1,l]
			ELSE
				LET tex = tex[1,x1-1]," ", tex[x1+1,l]
			END IF
			LET accText = tex
		END IF
		FOR x1 = 1 TO no_of_keys
			IF key[x1] IS NULL 
			OR (key[x1] = accName AND key_name[x1] = accText) THEN
				IF key[x1] IS NULL THEN
					LET key[x1] = accName.trim()
					LET key_name[x1] = accText.trim()
					LET no_of_keys = no_of_keys + 1
				END IF
				EXIT FOR
			END IF
		END FOR
	END FOR

END FUNCTION
--------------------------------------------------------------------------------
FUNCTION mkper_recs( st_node )
	DEFINE st_node om.DomNode
	DEFINE n om.DomNode
	DEFINE nl,nl2 om.NodeList
	DEFINE x,x2 SMALLINT
	DEFINE tabn CHAR(30)
	DEFINE line STRING

	LET nl = st_node.selectByPath("//RecordView")
	FOR x = 1 TO nl.getLength()
		LET n = nl.item(x)
		LET tabn = n.getAttribute("tabName")
		FOR x2 = 1 TO no_of_tabs
			IF tabn = tabs[x2] THEN
				LET tabn = "formonly"
			END IF
		END FOR
		IF tabn != "formonly" THEN
			LET nl2 = n.selectByPath("//Link")
			IF nl2.getLength() > 0 THEN
				LET line =  "SCREEN RECORD ", tabn CLIPPED, " ("
			END IF	
			FOR x2 = 1 TO nl2.getLength()
				LET n = nl2.item(x2)
				CASE x2 
--					WHEN 1
--						CALL out("		("||n.getAttribute("colName")||",")
					WHEN nl2.getLength()
						LET line = line.append(n.getAttribute("colName")||")")
--						CALL out("			"||n.getAttribute("colName")||")")
					OTHERWISE
						LET line = line.append(n.getAttribute("colName")||",")
--						CALL out("			"||n.getAttribute("colName")||",")
				END CASE
			END FOR
			IF line.getLength() > 0 THEN
				CALL out( line )
			END IF
		END IF
	END FOR

END FUNCTION
--------------------------------------------------------------------------------
FUNCTION mkper_tabs( st_node )
	DEFINE st_node om.DomNode
	DEFINE n om.DomNode
	DEFINE nl om.NodeList
	DEFINE x,x1,x2 SMALLINT
	
	LET nl = st_node.selectByPath("//FormField")
	LET x1 = 1
	FOR x = 1 TO nl.getLength()
		LET n = nl.item(x)
		IF n.getAttribute("sqlTabName") != "formonly" THEN
--			DISPLAY "mkper_tabs:",x1,":",n.getAttribute("sqlTabName")
			FOR x2 = 1 TO x1
				IF tabs[x2] IS NULL OR tabs[x2] = n.getAttribute("sqlTabName") THEN
					IF tabs[x2] IS NULL THEN 
						LET tabs[x2] = n.getAttribute("sqlTabName")
						LET x1 = x1 + 1
					END IF
					EXIT FOR
				END IF
		END FOR
		END IF
	END FOR

	LET nl = st_node.selectByPath("//Matrix")
	FOR x = 1 TO nl.getLength()
		LET n = nl.item(x)
		IF n.getAttribute("sqlTabName") != "formonly" THEN
--			DISPLAY "mkper_tabs:",x1,":",n.getAttribute("sqlTabName")
			FOR x2 = 1 TO x1
				IF tabs[x2] IS NULL OR tabs[x2] = n.getAttribute("sqlTabName") THEN
					IF tabs[x2] IS NULL THEN 
						LET tabs[x2] = n.getAttribute("sqlTabName")
						LET x1 = x1 + 1
					END IF
					EXIT FOR
				END IF
		END FOR
		END IF
	END FOR

	LET no_of_tabs = x1 - 1
--	DISPLAY "Tables:",no_of_tabs

END FUNCTION
--------------------------------------------------------------------------------
FUNCTION mkper_attr( st_node )
	DEFINE st_node om.DomNode
	DEFINE x SMALLINT
	DEFINE line STRING
	
	FOR x = 1 TO fields
		IF field[x].ty[1,3] = "RIP" THEN
			CONTINUE FOR
		END IF
		IF DOWNSHIFT(field[x].tb) = "formonly" THEN 
			LET field[x].tb = UPSHIFT( field[x].tb ) 
		END IF
		IF field[x].tb IS NOT NULL THEN
			LET line = field[x].ty CLIPPED, " ",
               	field[x].id CLIPPED, " = ",
               	field[x].tb CLIPPED, ".",
               	field[x].nm CLIPPED,
               	field[x].ar CLIPPED, ";"
		ELSE
			LET line = field[x].ty CLIPPED, " ",
               	field[x].id CLIPPED, " : ",
               	field[x].nm CLIPPED,
               	field[x].ar CLIPPED, ";"
		END IF
		CALL out( line ) 
	END FOR

END FUNCTION
--------------------------------------------------------------------------------
FUNCTION out( line )
	DEFINE line STRING
	
--	DISPLAY line.trimright()
	CALL chan.write( line.trimright() )

END FUNCTION
--------------------------------------------------------------------------------
FUNCTION keyact(key)
	DEFINE key STRING
	DEFINE act STRING
	DEFINE nl om.NodeList
	DEFINE n om.domNode

	LET key = key.toLowerCase()
	LET nl = actions.selectByPath("//Rule[@key=\""||key.trim()||"\"]")
	IF nl.getLength() > 0 THEN
		LET n = nl.Item(1)
		LET act = n.getAttribute("action")
	ELSE
		DISPLAY "Failed to found:",key
		RETURN key
	END IF
	
	RETURN act

END FUNCTION
--------------------------------------------------------------------------------
